#include <stdio.h>

// скалярные типы данных C:

//---------------------------------------------------------

void test01( void ) {      // различные представления
   int i = 123;
   short is = 12;
   char ic1 = 3, ic2 = '2';
   long il = 5932;
   long long ill = 123456; 
   printf( "одни и те же данные могут представляться по-разному:\n" ); 
   printf( " %d \n %d \n %d \n %d \n %lX \n %llX \n",
              i,    is,   ic1,  ic2,  il,    ill );
   printf( "%c => %i\n", ic2, ic2 );
}

//---------------------------------------------------------

void test02( void ) {      // "неточность" вещественных данных
   printf( "все вещественные типы - это только приближённые данные:\n" ); 
   double rd = 3.14159265358979323846264338327950288419716939937510;
   float rf = rd;  
#define FMT "%15.12f"
   printf( FMT" - "FMT" = "FMT"\n", rd, rf, rd - rf );
#undef FMT
}

//---------------------------------------------------------

void test03( void ) {      // перечисления - константы 
   enum months { JAN = 1, FEB, MAR, APR, MAY, JUN,
                 JUL, AUG, SEP, OCT, NOV, DEC };
   int days[] = { 31, 28, 31, 30, 31, 30, 
                  31, 31, 30, 31, 30, 31 }, i;
   printf( "enum - это удобный препроцессорный обман:\n" ); 
   for( i = JAN; i <= DEC; i++ )
      printf( "%d:%d%s", i, days[ i - 1 ], i != DEC ? " , " : "\n" );
}

//---------------------------------------------------------

void ( *tests[] )( void ) = {          // последовательность тестов
        test01, test02, test03 //, test04, test05, test06, ...
};
#include "main.c"

